/*
	ChamereonUBS PROM emulator

	Copyright(C) 2003 Tatsutuki Satoh

	2003. 8. 1 Ver1.00
	2003. 4.30 Beta1
	2003. 5. 6 Beta2 Support Reset Output

	note:

	@RpC̓t[̃RpCAMINGWgpĂ܂B

	@̃vÓACypressЂ́udy|trap̊JLbgv
	IveB}CÝuJIUSBvp̐\tgx[XɎgpĂ
	܂B

*/
#include <windows.h>
#include <stdio.h>
#include <string.h>

// MINGWWarning
#if !defined(_BYTE_DEFINED)
#define _BYTE_DEFINED
#define _WORD_DEFINED
#endif

// ez-usb access routine
#include "ezusb.h"
// JItrap̔ėpCu
#include "gpfw.h"

//t@[EFAf[^̎荞
extern BYTE fw_bin[];

// USBR}hpobt@
BYTE buf[64];

/* CPLDŎCNgTCY */
#define BLOCK_SIZE 0x1000
#define BLOCK_MASK (BLOCK_SIZE-1)

#define RETRY_CNT 10

/* ROMt@Cpobt@ */
static BYTE data_buf[0x80000];
static BYTE read_buf[BLOCK_SIZE];

/* -------------------- EZ-USB interface -------------------- */

//CPIPE
void usb_cpipe_write(void *buf,DWORD size)
{
	ezusb_bulk_write(GPFW_CPIPE,buf,size);
}

//RPIPEǂݍ
void usb_rpipe_read(void *buf,DWORD size)
{
	ezusb_bulk_read(GPFW_RPIPE,buf,size);
	if(ezusb_bulk_read_left(TRUE)==0xffffffff)
	{
		printf("RPIPE read error\n!");
	}
}

//Fast WRITE f[^]
void usb_fwrite(BYTE gpio,void *data,DWORD size)
{
	BYTE cmd[4];

	cmd[0]=GPFW_BWRITE | (gpio&0x0f);
	cmd[1]=(BYTE)(size & 0x3f);
	cmd[2]=(BYTE)(size >> 6);
	cmd[3]=(BYTE)(size >> 14);
	if(!ezusb_bulk_write(GPFW_CPIPE,cmd,4))
		if(!ezusb_bulk_write(GPFW_WPIPE,data,size))
			return;

	printf("CPIPE / WPIPE write error\n!");
	return;
}

#define PC0_OUT 0x01
#define PC1_OUT 0x02
#define PC2_OUT 0x04
#define PC3_OUT 0x08
#define PC0_IN  0x00
#define PC1_IN  0x00
#define PC2_IN  0x00
#define PC3_IN  0x00

/* setup register bits */
#define A13EN 0x01
#define A14EN 0x02
#define A15EN 0x04
#define A16EN 0x08
#define A17EN 0x10
#define A18EN 0x20 /* A18 == pin31 */
#define F18EN 0x40 /* A18 == pin1  */

/* ROM types */
#define SEL_2764  0x00
#define SEL_27128 (A13EN)
#define SEL_27256 (A13EN|A14EN)
#define SEL_27512 (A13EN|A14EN|A15EN)
#define SEL_27010 (A13EN|A14EN|A15EN|A16EN)
#define SEL_27020 (A13EN|A14EN|A15EN|A16EN|A17EN)
#define SEL_27040 (A13EN|A14EN|A15EN|A16EN|A17EN|A18EN)
#define SEL_29040 (A13EN|A14EN|A15EN|A16EN|A17EN|F18EN)

#define MAX_ROM_TYPES 8

static const BYTE rom_value[MAX_ROM_TYPES] =
{	SEL_2764 , SEL_27128 , SEL_27256 , SEL_27512 , SEL_27010 , SEL_27020 , SEL_27040 , SEL_29040};

static const char *rom_name[MAX_ROM_TYPES] =
{	"2764" , "27128" , "27256","27512","27010","27020","27040","29040" };

static const DWORD rom_size[MAX_ROM_TYPES] =
{	0x2000 , 0x4000 , 0x8000 , 0x10000 , 0x20000 , 0x40000 , 0x80000 , 0x80000 };

int str_to_romtype(char *string)
{
	int i;

	for(i=0;i<MAX_ROM_TYPES;i++)
	{
		if(strcmp(string,rom_name[i])==0)
		{
			printf("ROM type %s[%d]\n",rom_name[i],i);
			return i;
		}
	}
	return -1;
}

DWORD file_read(char *file_name,void *buf , DWORD size)
{
	HANDLE hndl;
	DWORD read_size;

	// file open
	hndl = CreateFile(file_name,GENERIC_READ,
		0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
	if( hndl==INVALID_HANDLE_VALUE)
		return 0;

	if( !ReadFile(hndl,buf,size,&read_size,NULL) )
	{
		CloseHandle(hndl);
		return 0;
	}
	CloseHandle(hndl);
	return read_size;
}

/* -------------------- Emulator I/F -------------------- */

void prome_write(DWORD addr,BYTE *data,DWORD size)
{
	int c;
	DWORD block_length;
	DWORD adj_addr;

	/* adjust for DWORD orign */
	addr &= ~3;
	size = (size+3) & ~3;

//	printf("Writeing %06Xh - %06Xh\n",addr,addr+size-1);

	while( addr < size)
	{
		block_length = BLOCK_SIZE - (addr % BLOCK_SIZE); // low 8bit limit */

		if(size-addr < block_length)
			block_length = size-addr;

		/* adjust Address for auto increment */
		adj_addr = (addr&~BLOCK_MASK) | ((addr-4)&BLOCK_MASK);

printf("\rWriteing %06Xh - %06Xh",addr,addr+block_length-1);

		/* address write */
		c = 0;

		buf[c++]=GPFW_WRITE | 1;
		buf[c++]=(BYTE)adj_addr;
		buf[c++]=GPFW_WRITE | 2;
		buf[c++]=(BYTE)(adj_addr>>8);
		buf[c++]=GPFW_WRITE | 3;
		buf[c++]=(BYTE)(adj_addr>>16);
		/* data block write req */
		buf[c++]=GPFW_BWRITE | 0;
		buf[c++]=(BYTE)block_length & 0x3f;
		buf[c++]=(BYTE)(block_length>>6);
		buf[c++]=(BYTE)(block_length>>14);
		usb_cpipe_write(buf,c);
		/* data block write */
		ezusb_bulk_write(GPFW_WPIPE,data,block_length);

	 	addr += block_length;
		data += block_length;
	}
	printf(" Finish !\n");
}

int prome_verify(DWORD addr,BYTE *data,DWORD size)
{
	int c;
	DWORD block_length;
	DWORD adj_addr;
	int err=0;

	/* adjust for DWORD orign */
	addr &= ~3;
	size = (size+3) & ~3;

	/* adjust Address for auto increment */
//	printf("Verifying %06Xh - %06Xh\n",addr,addr+size-1);
	while( addr < size)
	{
		block_length = BLOCK_SIZE - (addr % BLOCK_SIZE); // low 12bit limit */

//		adj_addr = (addr&~BLOCK_MASK) | ((addr-4)&BLOCK_MASK);
		adj_addr = addr;

		if(size-addr < block_length)
			block_length = size-addr;

printf("\rVerifying %06Xh - %06Xh",addr,addr+block_length-1);
		/* address write */
		c = 0;

		buf[c++]=GPFW_WRITE | 1;
		buf[c++]=(BYTE)adj_addr;
		buf[c++]=GPFW_WRITE | 2;
		buf[c++]=(BYTE)(adj_addr>>8);
		buf[c++]=GPFW_WRITE | 3;
		buf[c++]=(BYTE)(adj_addr>>16); // read flag

		/* data block read req */
		buf[c++]=GPFW_BREAD | 0;
		buf[c++]=(BYTE)block_length & 0x3f;
		buf[c++]=(BYTE)(block_length>>6);
		buf[c++]=(BYTE)(block_length>>14);
		usb_cpipe_write(buf,c);

		/* data block read */
		usb_rpipe_read(read_buf,block_length);
		/* verify data */
		if(memcmp(data,read_buf,block_length))
		{
			int i;

			for(i=0;i<block_length;i++)
			{
				if(data[i]!=read_buf[i])
				{
					if(err>-8)
						printf("\nVerify error %06X = file[%02X] : ram[%02X]",addr+i,data[i],read_buf[i]);
					err--;
				}
			}
		}
	 	addr += block_length;
		data += block_length;
	}
	if(err<-4)
		printf("\nVerify error Total %d Bytes",-err);

	printf("\nFinish !\n");
	return err;
}

int prome_run_mode(int run,int rom_type,DWORD trigger_address,int reset_level)
{
	int c=0;
	BYTE cntrl_val;

	/* controll register value */
	cntrl_val = run ? 0x80 : 0x00;

	/* reset controll */
	switch(reset_level|0x20)
	{
	case 'l': cntrl_val |= 0x40; break;
	case 'h': cntrl_val |= 0x60; break;
/*	case 'z': cntrl_val |= 0x00; break; */
	}

	/* ROM type select */
	buf[c++]=GPFW_WRITE | 7;
	buf[c++]=rom_value[rom_type];

	/* Trigger set */
	if(trigger_address & 0x80000000)
	{
		/* single or pulse */
		if(trigger_address & 0x40000000)
			cntrl_val |= 0x10;
		/* address */
		buf[c++]=GPFW_WRITE | 1;
		buf[c++]=(BYTE)trigger_address;
		buf[c++]=GPFW_WRITE | 2;
		buf[c++]=(BYTE)(trigger_address>>8);
		buf[c++]=GPFW_WRITE | 3;
		buf[c++]=(BYTE)(trigger_address>>16);
	}

	/* controll port */
	buf[c++]=GPFW_WRITE | 6;
	buf[c++]=cntrl_val;
	usb_cpipe_write(buf,c);

	return 0;
}

int prome_clear_trigger(void)
{
	int c=0;

	/* clear trigger */
	buf[c++]=GPFW_WRITE | 4; /* dummy port */
	buf[c++]=0;
	usb_cpipe_write(buf,c);

	return 0;
}

int prome_init(void)
{
	int c , i;

	printf("Setup EZ-USB\n");
	if( ezusb_init(0,fw_bin,"GPFW","V100fix") )
	{
		printf("Can't found EZ-USB Device 0\n");
		return 1;
	}

	c=0;
	buf[c++]=GPFW_BUS | 0x00;  // streach=0
	buf[c++]= 0x00;            // RMOD = 00 , TMOD = 00

	/* PC0-PC3o͐ݒ */
	buf[c++]=GPFW_DIR | PC0_OUT | PC1_OUT | PC2_OUT | PC3_OUT;
	/* read CPLD check & version code! */
	buf[c++]=GPFW_READ | 0x0d;
	buf[c++]=GPFW_READ | 0x0e;
	buf[c++]=GPFW_READ | 0x0f;

	/* PC0-PC3o͂łԂĂƉ̂ŁAU͂Ɍ */
	buf[c++]=GPFW_DIR;
	usb_cpipe_write(buf,c);

	/* get check code */
	usb_rpipe_read(buf,3);
	buf[7] = 0x00;

	/* CPLD check! */
	if(buf[0]!='R' || buf[1]!='E')
	{
		printf("BAD CPLD ! '%s'\n",buf);
		ezusb_close();
		return 1;
	}
	if(buf[2]!=0x10)
	{
		printf("No match CPLD Version , req=0x10,ans=%02x\n",buf[2]);
		ezusb_close();
		return 1;
	}

	/* CPLDOKȂA炽߂PC0-PC3óAVOgK̃NA */
	c=0;
	buf[c++]=GPFW_DIR | PC0_OUT | PC1_OUT | PC2_OUT | PC3_OUT;
	usb_cpipe_write(buf,c);

	return 0;
}

void prome_end(void)
{
	ezusb_close();
}

/* -------------------- finish -------------------- */
int escape(int ret_code,int wait_time)
{
	if(wait_time>0)
	{
		printf("Waiting %dmsec.\n",wait_time);
		sleep(wait_time);
	} else if(wait_time==0)
	{
		printf("HIT ANY KEY\n");
		getch();
	}
	exit(ret_code);
}

/* -------------------- MAIN -------------------- */


// C
int main(int argc,char *argv[])
{
	DWORD file_size;
	char filename[128];

	int i,err;
	int retry;
	int hexa_mode , rom_type , all_mode;
	BYTE pad_data;
	BYTE ver_mode;
	DWORD trg_a,trigger_mode;
	int reset_on,reset_off;
	int wait_time;

	// ^Cg\
	printf("\n\
ChamereonUSB PROM emulator Version 1.00\n\
Copyrght(C) 2003 T&A Tatsuuki Satoh\n");

	if(argc<2)
	{
		//@g
		printf("\
Usage: chamrome [filename] [options]\n\
  filename : Binary emuration ROM image\n\
  options  :\n\
    -r[type]   : select ROM type\n\
                   2764,27128,27256,27512,27010,27020,27040 or 29040\n\
    -a         : write all range of ROM size\n\
    -p[pad]    : set PAD code\n\
    -v         : Verify only\n\
    -ts[addr]  : Single Trigger\n\
    -tp[addr]  : Pulse Trigger\n\
    -tc        : Clear Single Trigger\n\
    -s[on][off]: Reset Output Control\n\
               : -sLZ = OpenDrain Active LOW(Default)
               : -sLH = Active LOW\n\
               : -sHL = Active HIGH\n\
    -w[msec]   : Wait After Finish,0=KEY Wait\n\
");
		escape(1,0);
	}

	// R}hC̉
	hexa_mode = 0;
	all_mode = 0;
 	rom_type = -1;
	pad_data = 0xff;
	ver_mode = 0;
	filename[0] = 0x00;
	trigger_mode    = 0;
	reset_on  = 'l';
	reset_off = 'z';
	wait_time = -1;

	for( i=1 ; i<argc ; i++ )
	{
		if( argv[i][0] == '/' || argv[i][0] == '-')
		{
			// IvVXCb`
			switch( argv[i][1]|0x20 )
			{
			case 'a': all_mode  = 1; break;
			case 'p': pad_data  = atoi(&argv[i][2]); break;
			case 'h': hexa_mode = 1; break;
			case 'r': rom_type  = str_to_romtype(&argv[i][2]); break;
			case 'v': ver_mode  = 1; break;
			case 't': 
				switch(argv[i][2]|0x20)
				{
				case 's': trigger_mode = 0x80000000; break;
				case 'p': trigger_mode = 0xc0000000; break;
				case 'c': trigger_mode = 0x20000000; break; // clear
				}
				if(trigger_mode&0x80000000)
				{
					if(sscanf(&argv[i][3],"%x",&trg_a))
						trigger_mode |= trg_a;
					else
						trigger_mode = 0;
				}
				break;
			case 's':
				reset_on  = argv[i][2]|0x20;
				if(argv[i][2])
					reset_off = argv[i][3]|0x20;
				break;
			case 'w':
				wait_time = 0;
				sscanf(&argv[i][2],"%d",&wait_time);
				break;
			}
		}
		else
		{
			// t@C
			sprintf(filename,"%s",argv[i]);
		}
	}

	// v[u|[g̏ƁA^[Qbgd`FbN
	err = prome_init();
	if(err)
		escape(err,wait_time);

	/* gK[NA[[h */
	if(trigger_mode&0x20000000)
	{
		printf("Clear Trigger\n");
		prome_clear_trigger();
		prome_end();
		escape(0,wait_time);
	}

	/* t@C`FbN */
	if( filename[0] == 0)
	{
		printf("\nno file\n");
		prome_end();
		escape(1,wait_time);
	}

	/* ^Cv`FbN */
	if( rom_type < 0)
	{
		printf("\nBad ROM type\n");
		prome_end();
		escape(1,wait_time);
	}

	/* pbhR[hŃobt@𖄂߂Ă */
	memset(data_buf,pad_data,rom_size[rom_type]);

	/* f[^[h */
	file_size = file_read(filename , data_buf , rom_size[rom_type] );

	if(file_size == 0)
	{
		printf("Can't read File %s\n",filename);
		escape(1,wait_time);
	}

	printf("File name '%s' : size %d \n",filename , file_size);

	/* ROM̑S̈ƂɃTCYύX */
	if(all_mode)
		file_size = rom_size[rom_type];

	/* ROM݃[hݒ */
	prome_run_mode(FALSE,rom_type,trigger_mode,reset_on);

	if(ver_mode)
		prome_verify(0,data_buf,file_size);
	else
	{
		for(retry=RETRY_CNT;retry;retry--)
		{
			if(prome_init())
			{
				prome_end();
				escape(err,wait_time);
			}
			/* f[^Cg */
			prome_write(0,data_buf,file_size);
			/* [h[hɐ؂ւ */
			if(!prome_verify(0,data_buf,file_size))
				break;
		}
		if(!retry)
			err = 1;
	}

	/* gK[AhX\ */
	if(trigger_mode&0x80000000)
	{
		printf("Trigger = %06xH:%s\n",trigger_mode&0x00ffffff , trigger_mode&0x40000000 ? "PULSE":"SINGLE");
	}

	/* s */
	prome_run_mode(TRUE,rom_type,trigger_mode,reset_off);
	printf("Emulator Start (RESET=%C)\n",reset_off&0xdf);

	prome_end();
	escape(err,wait_time);
}

